#lang racket/base
(require racket/cmdline
         "global.rkt"
         "mem.rkt")

;; Disk:

(define (read-disk! filename)
  (printf "Reading disk ~s...\n" filename)
  (call-with-input-file filename
    (lambda (in)
      (for ([n (in-port read in)]
            [addr (in-naturals)])
        (unless (exact-integer? n)
          (error 'read-disk! "bad disk content: ~e" n))
        (set-mem! addr n)))))

;; Cleaner, but depends on Racket v5.1:
#;
(command-line
 #:args ([disk "disk"])
 (read-disk! disk))

;; Works with v5.0:
(command-line
 #:args disk
 (case (length disk)
   [(0) (read-disk! "disk")]
   [(1) (read-disk! (car disk))]
   [else (raise-user-error 
          'jam 
          "expects a single disk file on command line")]))
